#  bisec.jlプログラム
#  2分法による方程式の解法プログラム
#  @printf()を使用
#　使い方　c:\>julia bisec.jl

using Printf #  @printf()を使用

#グローバル変数
a=2 #f(x)=x*x-a
LIMIT=1e-20 #終了条件

#下請け関数の定義
#f()関数
"""関数値の計算"""
function f(x)
    x*x-a
end 
#f()関数の終わり

#main()関数
function main()
    #初期設定
    print("xpを入力してください:")
    xp=parse(Float64,readline())
    print("xnを入力してください:")
    xn=parse(Float64,readline())

    #繰り返し処理
    while (xp-xn)*(xp-xn)>LIMIT #終了条件を満たすまで繰り返す
        xmid=(xp+xn)/2          #新たな中間値の計算
        if f(xmid)>0            #中間値が正なら
            xp=xmid             #xpを更新
        else                    #中間値が正でなければ
            xn=xmid             #xnを更新
        end
        @printf("%-15.15g \t %-15.15g\n",xn,xp)
    end
end

# main()関数の実行
main()

#bisec.jlの終わり