#  freefall.jlプログラム
#  自由落下のシミュレーション
#  自由落下の運動法方程式を数値的に解きます
#　使い方　c:\>julia freefall.jl

using Printf #  @printf()を使用

#グローバル変数
G=9.80665 #重力加速度

#main()関数
function main()
    t = 0.0   #時刻t
    h = 0.01  #時刻の刻み幅

    #係数の入力
    print("初速度v0を入力してください:")
    v = parse(Float64,readline())
    print("初期高度x0を入力してください:")
    x = parse(Float64,readline())
    @printf("%-7.2f %-10.7f %-10.7f\n",t,x,v) #現在時刻と現在の位置

    #自由落下の計算
    while x > 0  #地面に達するまで計算
        t += h #時刻の更新
        v += G*h #速度の計算
        x -= v * h #位置の更新
        @printf("%-7.2f %-10.7f %-10.7f\n",t,x,v) #現在時刻と現在の位置
    end
end

# main()関数の実行
main()

# freefall.jlの終わり