#  gfreefall.jlプログラム
#  自由落下のシミュレーション
#  自由落下の運動法方程式を数値的に解きます
#　Plotsによるグラフ描画機能付き
#　使い方　c:\>julia gfreefall.jl

using Printf #  @printf()を使用
using Plots  #　グラフ描画

#グローバル変数
G=9.80665 #重力加速度

#main()関数
function main()
    t = 0.0   #時刻t
    h = 0.01  #時刻の刻み幅

    #係数の入力
    print("初速度v0を入力してください:")
    v = parse(Float64,readline())
    print("初期高度x0を入力してください:")
    x = parse(Float64,readline())
    @printf("%-7.2f %-10.7f %-10.7f\n",t,x,v) #現在時刻と現在の位置
　　#グラフデータに現在位置を追加
    tlist=[t]
    xlist=[x]

    #自由落下の計算
    while x > 0  #地面に達するまで計算
        t += h #時刻の更新
        v += G*h #速度の計算
        x -= v * h #位置の更新
        @printf("%-7.2f %-10.7f %-10.7f\n",t,x,v) #現在時刻と現在の位置
　　    #グラフデータに現在位置を追加
        push!(tlist,t)
        push!(xlist,x)
    end
    #グラフの表示
    p = plot(tlist, xlist) #グラフをプロット
    display(p)             #描画
    readline(stdin)        #Enterキーを待つ
end

# main()関数の実行
main()

# gfreefall.jlの終わり