#  godefreefall.jlプログラム
#  自由落下のシミュレーション
#  自由落下の運動法方程式を数値的に解きます
#　DifferentialEquationsパッケージを利用します
#　Plotsによるグラフ描画機能付き
#　使い方　c:\>julia godefreefall.jl

using DifferentialEquations # 微分方程式を解く
using Plots  #　グラフ描画

#グローバル変数
G=9.80665 #重力加速度

#下請け関数の定義
#f()関数
function f(du , u , p , t)
""" 微分方程式の記述"""
    du[1] = -G
    du[2] = u[1]
end
#f()関数の終わり

#main()関数
function main()
    u0=[0.0 ; 100.0] #初期値の設定
    tspan=(0.0 , 5.0)#時刻の範囲（５秒後まで）
    prob=ODEProblem(f , u0 , tspan) #問題の定義
    sol=solve(prob) #微分方程式を解く
    p=plot(sol) #グラフをプロット
    display(p)  #描画
    readline()  #Enterキーを待つ
end

# main()関数の実行
main()

# godefreefall.jlの終わり