#  lander.jlプログラム
#  落下運動のシミュレーション
#  逆噴射をする，着陸船のシミュレーションです
#　使い方　c:\>julia lander.jl

using Printf #  @printf()を使用

#グローバル変数
F=1.5 #逆噴射の加速度を決定する係数
G=9.80665 #重力加速度

#下請け関数の定義
#retrofire()関数
function retrofire(t,tf)
""" 逆噴射の制御を担当する関数"""
    if t >= tf
        return -F*G # 逆噴射
    else
        return 0.0  #逆噴射なし
    end
end
#retrofire()関数の終わり

#main()関数
function main()
    t = 0.0   #時刻t
    h = 0.01  #時刻の刻み幅

    #係数の入力
    print("初速度v0を入力してください:")
    v = parse(Float64,readline())
    print("初期高度x0を入力してください:")
    x0 = parse(Float64,readline())
    print("逆噴射開始時刻tfを入力してください:")
    tf = parse(Float64,readline())
    x=x0 #初期高度の設定
    @printf("%-7.2f %-10.7f %-10.7f\n",t,x,v) #現在時刻と現在の位置

    #自由落下の計算
    while (x>0) && (x<=x0)  #地面に達するか初期高度より高くなるまで計算
        t += h #時刻の更新
        v+=(G+retrofire(t,tf))*h #速度の計算
        x -= v * h #位置の更新
        @printf("%-7.2f %-10.7f %-10.7f\n",t,x,v) #現在時刻と現在の位置
    end
end

# main()関数の実行
main()

# lander.jlの終わり