#  gauss.jlプログラム
#  ガウスの消去法
#  ガウスの消去法で連立方程式を解きます
#　使い方　c:\>julia gauss.jl

#グローバル変数
N=9 #N元連立方程式を解く
r=[4 -1 0 -1 0 0 0 0 0 0 ; -1 4 -1 0 -1 0 0 0 0 0
   0 -1 4 0 0 -1 0 0 0 0.25 ; -1 0 0 4 -1 0 -1 0 0 0
   0 -1 0 -1 4 -1 0 -1 0 0 ; 0 0 -1 0 -1 4 0 0 -1 0.5
   0 0 0 -1 0 0 4 -1 0 0.25 ; 0 0 0 0 -1 0 -1 4 -1 0.5
   0 0 0 0 0 -1 0 -1 4 1.5]  #拡大係数行列

#下請け関数の定義
#forward()関数
function forward(r)
"""    前進消去   """
    for i = 1 : N
        rii=r[i , i]
        for j = i : N+1
            r[i , j]/=rii #行iの係数をriiで割る
        end
        for k = i+1 : N #i+1行以下の処理
            rki=r[k , i]
            for j = i : N+1
                r[k , j]-=r[i , j] * rki #先頭項の消去
            end
        end
     end
end
#forward()関数の終わり

#backward()関数
function backward(r,x)
    """
    後退代入
    """
    for i = N : -1 : 1#下段から上段に向けて逐次代入
        sum=0.0 
        for j = i : N
            sum += r[i , j]*x[j] #各項の和
        end
        x[i] = r[i , N + 1] - sum #xiの計算
    end
end
#backward()関数の終わり

#main()関数
function main()
    x=zeros(Float64, N) #未知変数
    forward(r) #前進消去
    backward(r,x) #後退代入
    #結果の出力
    println(r)
    println(x)
end
# main()関数の実行
main()

#gauss.jlの終わり