#  glaplace.jlプログラム
#  ラプラス方程式の解法プログラム 
#  反復法によりラプラス方程式を解きます
#  結果をグラフ表示します
#　使い方　c:\>julia glaplace.jl

using Plots  #　グラフ描画

#グローバル変数
LIMIT=1000 #反復回数の上限
N=101 #x軸方向の分割数
M=101 #y軸方向の分割数

#下請け関数の定義
#iteration()関数
function iteration(u)
"""  1回分の反復計算   """
    u_next= zeros(Float64, N , M) #次ステップのuij
    #次のステップの値を計算
    for i = 2 : N-1
        for j = 2 : M-1
            u_next[i,j]=(u[i,j-1]+u[i-1,j]+u[i+1,j]+u[i,j+1])/4
        end
    end
    #uの更新
    for i = 2 :N-1
        for j =2 : M-1
            u[i,j]=u_next[i,j]
        end
    end
end
#iteration()関数の終わり

#main()関数
function main()
    u= zeros(Float64, N , M) # uijの初期化
    for i = 1 : M
        u[1 , i]=sin(2*π*i/(M))
    end
    #反復法の計算
    for i = 1 : LIMIT
        iteration(u)
    end
    println(u)#結果の出力
    #グラフ描画
    p = plot(u,seriestype=:wireframe)#wireframe形式
#    p = plot(u,seriestype=:surface)#surface形式
    display(p)             #描画
    readline(stdin)        #Enterキーを待つ    
end

# main()関数の実行
main()

#glaplace.jlの終わり