#  gsa0.jlプログラム
#  シンプルなエージェントシミュレーション
#  2次元平面内で動作するエージェント
#  結果をグラフ描画する
#　使い方　c:\>julia gsa0.jl

using Plots  #　グラフ描画

#グローバル変数
TIMELIMIT = 100  # シミュレーション打ち切り時刻
W = 60 # 表示領域の大きさ

#Agent型の定義
mutable struct Agent
    category::Int #カテゴリ
    x::Float64    #x座標
    y::Float64    #y座標
    dx::Float64   #x座標の増分
    dy::Float64   #y座標の増分
end

#下請け関数の定義
#gput()関数
function gput(as)
    """状態のグラフ出力"""
    x = []
    y = []
    for a in as
        push!(x , a.x)
        push!(y , a.y)
    end
    p = scatter(xlims=(0,W),ylims=(0,W)) #表示ウィンドウ作成
    p = scatter!(x , y) # プロット
    display(p) # 描画
    sleep(0.5) # 待ち合わせ
end
#gput()関数の終わり

#calcnext()関数
function calcnext(a)
    """次時刻の状態の計算"""
    if a.category == 0
        cat0(a) # カテゴリ0の計算
    else # 合致するカテゴリがない
        print("ERROR カテゴリがありません\n")
    end
end 
#calcnext()関数の終わり

#cat0()関数
function cat0(a)
    """カテゴリ0の計算"""
    # 内部状態の更新
    a.dx = reverse(a.dx)
    a.dy = reverse(a.dy)
    # 内部状態によって次の座標を決定
    a.x += a.dx
    a.y += a.dy
end 
#cat0()関数の終わり

#reverse()関数
function reverse(i)
    """cat0()関数の下請け関数"""
    if i == 0
        return 1
    else
        return 0
    end
end 
#reverse()関数の終わり

#putstate()関数
function putstate(a)
    """状態の出力"""
    println(a.x," ",a.y)
end
#putstate()関数の終わり

# calcn()関数
function calcn(as)
    """次時刻の状態を計算"""
    for a in as
        calcnext(a)
        putstate(a)
    end
end
# calcn()関数の終わり

#main()関数
function main()
    #初期化
    as = [Agent(0,0,0,0,1)] # カテゴリ0のエージェントを生成
    putstate(as[1])
    gput(as)   # グラフ出力
    # エージェントシミュレーション
    for t = 1 : TIMELIMIT
        calcn(as)  # 次時刻の状態を計算
        gput(as)   # グラフ出力
    end
end

# main()関数の実行
main()

#gsa0.jlの終わり