#  sa0.jlプログラム
#  シンプルなエージェントシミュレーション
#  2次元平面内で動作するエージェント
#　使い方　c:\>julia sa0.jl

#グローバル変数
TIMELIMIT = 100  # シミュレーション打ち切り時刻

#Agent型の定義
mutable struct Agent
    category::Int #カテゴリ
    x::Float64    #x座標
    y::Float64    #y座標
    dx::Float64   #x座標の増分
    dy::Float64   #y座標の増分
end

#下請け関数の定義
#calcnext()関数
function calcnext(a)
    """次時刻の状態の計算"""
    if a.category == 0
        cat0(a) # カテゴリ0の計算
    else # 合致するカテゴリがない
        print("ERROR カテゴリがありません\n")
    end
end 
#calcnext()関数の終わり

#cat0()関数
function cat0(a)
    """カテゴリ0の計算"""
    # 内部状態の更新
    a.dx = reverse(a.dx)
    a.dy = reverse(a.dy)
    # 内部状態によって次の座標を決定
    a.x += a.dx
    a.y += a.dy
end 
#cat0()関数の終わり

#reverse()関数
function reverse(i)
    """cat0()関数の下請け関数"""
    if i == 0
        return 1
    else
        return 0
    end
end 
#reverse()関数の終わり

#putstate()関数
function putstate(a)
    """状態の出力"""
    println(a.x," ",a.y)
end
#putstate()関数の終わり

# calcn()関数
function calcn(as)
    """次時刻の状態を計算"""
    for a in as
        calcnext(a)
        putstate(a)
    end
end
# calcn()関数の終わり

#main()関数
function main()
    #初期化
    as = [Agent(0,0,0,0,1)] # カテゴリ0のエージェントを生成
    putstate(as[1])
    # エージェントシミュレーション
    for t = 1 : TIMELIMIT
        calcn(as)  # 次時刻の状態を計算
    end
end

# main()関数の実行
main()

#sa0.jlの終わり